import{s as ot,f as lt,n as ct,o as ut}from"../chunks/scheduler.37c15a92.js";import{S as gt,i as ht,g as n,s as i,r as dt,m as M,H as it,A as ft,h as l,f as e,c as r,j as O,u as vt,x as T,n as k,B as rt,k as x,y as c,a,v as wt,d as _t,t as xt,w as Lt}from"../chunks/index.7cb9c9b8.js";import{H as bt}from"../chunks/Heading.d3928e2a.js";function yt(K){let m,P,z,C,g,$,u,V,S,h,X="In the last unit, we learned our first reinforcement learning algorithm: Q-Learning, <strong>implemented it from scratch</strong>, and trained it in two environments, FrozenLake-v1 ☃️ and Taxi-v3 🚕.",Q,p,U,L,Y="state space was discrete and small",W,o,Z,R,pt='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mn>1</mn><msup><mn>0</mn><mn>9</mn></msup></mrow><annotation encoding="application/x-tex">10^{9}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8141em;"></span><span class="mord">1</span><span class="mord"><span class="mord">0</span><span class="msupsub"><span class="vlist-t"><span class="vlist-r"><span class="vlist" style="height:0.8141em;"><span style="top:-3.063em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">9</span></span></span></span></span></span></span></span></span></span></span></span>',E,A,mt='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mn>1</mn><msup><mn>0</mn><mn>11</mn></msup></mrow><annotation encoding="application/x-tex">10^{11}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8141em;"></span><span class="mord">1</span><span class="mord"><span class="mord">0</span><span class="msupsub"><span class="vlist-t"><span class="vlist-r"><span class="vlist" style="height:0.8141em;"><span style="top:-3.063em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">11</span></span></span></span></span></span></span></span></span></span></span></span>',D,J,q,d,tt="But as we’ll see, producing and updating a <strong>Q-table can become ineffective in large state space environments.</strong>",F,f,et="So in this unit, <strong>we’ll study our first Deep Reinforcement Learning agent</strong>: Deep Q-Learning. Instead of using a Q-table, Deep Q-Learning uses a Neural Network that takes a state and approximates Q-values for each action based on that state.",I,v,st='And <strong>we’ll train it to play Space Invaders and other Atari environments using <a href="https://github.com/DLR-RM/rl-baselines3-zoo" rel="nofollow">RL-Zoo</a></strong>, a training framework for RL using Stable-Baselines that provides scripts for training, evaluating agents, tuning hyperparameters, plotting results, and recording videos.',G,w,at,N,_,nt="So let’s get started! 🚀",j,H,B;return g=new bt({props:{title:"Deep Q-Learning",local:"deep-q-learning",headingTag:"h1"}}),{c(){m=n("meta"),P=i(),z=n("p"),C=i(),dt(g.$$.fragment),$=i(),u=n("img"),S=i(),h=n("p"),h.innerHTML=X,Q=i(),p=n("p"),U=M("We got excellent results with this simple algorithm, but these environments were relatively simple because the "),L=n("strong"),L.textContent=Y,W=M(" (16 different states for FrozenLake-v1 and 500 for Taxi-v3). For comparison, the state space in Atari games can "),o=n("strong"),Z=M("contain"),R=new it(!1),E=M(" to"),A=new it(!1),D=M(" states"),J=M("."),q=i(),d=n("p"),d.innerHTML=tt,F=i(),f=n("p"),f.innerHTML=et,I=i(),v=n("p"),v.innerHTML=st,G=i(),w=n("img"),N=i(),_=n("p"),_.textContent=nt,j=i(),H=n("p"),this.h()},l(t){const s=ft("svelte-u9bgzb",document.head);m=l(s,"META",{name:!0,content:!0}),s.forEach(e),P=r(t),z=l(t,"P",{}),O(z).forEach(e),C=r(t),vt(g.$$.fragment,t),$=r(t),u=l(t,"IMG",{src:!0,alt:!0,width:!0}),S=r(t),h=l(t,"P",{"data-svelte-h":!0}),T(h)!=="svelte-zk4w0n"&&(h.innerHTML=X),Q=r(t),p=l(t,"P",{});var b=O(p);U=k(b,"We got excellent results with this simple algorithm, but these environments were relatively simple because the "),L=l(b,"STRONG",{"data-svelte-h":!0}),T(L)!=="svelte-1pgaspr"&&(L.textContent=Y),W=k(b," (16 different states for FrozenLake-v1 and 500 for Taxi-v3). For comparison, the state space in Atari games can "),o=l(b,"STRONG",{});var y=O(o);Z=k(y,"contain"),R=rt(y,!1),E=k(y," to"),A=rt(y,!1),D=k(y," states"),y.forEach(e),J=k(b,"."),b.forEach(e),q=r(t),d=l(t,"P",{"data-svelte-h":!0}),T(d)!=="svelte-1uzwejl"&&(d.innerHTML=tt),F=r(t),f=l(t,"P",{"data-svelte-h":!0}),T(f)!=="svelte-v9iwbb"&&(f.innerHTML=et),I=r(t),v=l(t,"P",{"data-svelte-h":!0}),T(v)!=="svelte-5gpd3h"&&(v.innerHTML=st),G=r(t),w=l(t,"IMG",{src:!0,alt:!0}),N=r(t),_=l(t,"P",{"data-svelte-h":!0}),T(_)!=="svelte-vkoquy"&&(_.textContent=nt),j=r(t),H=l(t,"P",{}),O(H).forEach(e),this.h()},h(){x(m,"name","hf:doc:metadata"),x(m,"content",Mt),lt(u.src,V="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/thumbnail.jpg")||x(u,"src",V),x(u,"alt","Unit 3 thumbnail"),x(u,"width","100%"),R.a=E,A.a=D,lt(w.src,at="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/atari-envs.gif")||x(w,"src",at),x(w,"alt","Environments")},m(t,s){c(document.head,m),a(t,P,s),a(t,z,s),a(t,C,s),wt(g,t,s),a(t,$,s),a(t,u,s),a(t,S,s),a(t,h,s),a(t,Q,s),a(t,p,s),c(p,U),c(p,L),c(p,W),c(p,o),c(o,Z),R.m(pt,o),c(o,E),A.m(mt,o),c(o,D),c(p,J),a(t,q,s),a(t,d,s),a(t,F,s),a(t,f,s),a(t,I,s),a(t,v,s),a(t,G,s),a(t,w,s),a(t,N,s),a(t,_,s),a(t,j,s),a(t,H,s),B=!0},p:ct,i(t){B||(_t(g.$$.fragment,t),B=!0)},o(t){xt(g.$$.fragment,t),B=!1},d(t){t&&(e(P),e(z),e(C),e($),e(u),e(S),e(h),e(Q),e(p),e(q),e(d),e(F),e(f),e(I),e(v),e(G),e(w),e(N),e(_),e(j),e(H)),e(m),Lt(g,t)}}}const Mt='{"title":"Deep Q-Learning","local":"deep-q-learning","sections":[],"depth":1}';function Tt(K){return ut(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Pt extends gt{constructor(m){super(),ht(this,m,Tt,yt,ot,{})}}export{Pt as component};
