import{s as Z,f as tt,n as et,o as nt}from"../chunks/scheduler.37c15a92.js";import{S as at,i as it,g as i,s,r as st,A as ot,h as o,f as n,c as l,j as Y,u as lt,x as r,k as G,y as rt,a,v as ut,d as gt,t as ct,w as mt}from"../chunks/index.7cb9c9b8.js";import{H as pt}from"../chunks/Heading.d3928e2a.js";function ft(F){let u,L,x,H,g,b,c,z,C,m,B="Since the beginning of this course, we learned to train agents in a <em>single-agent system</em>  where our agent was alone in its environment: it was <strong>not cooperating or collaborating with other agents</strong>.",P,p,O="This worked great, and the single-agent system is useful for many applications.",A,f,D='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/patchwork.jpg" alt="Patchwork"/> <figcaption>A patchwork of all the environments you’ve trained your agents on since the beginning of the course</figcaption>',$,h,J="But, as humans, <strong>we live in a multi-agent world</strong>. Our intelligence comes from interaction with other agents. And so, our <strong>goal is to create agents that can interact with other humans and other agents</strong>.",I,d,K="Consequently, we must study how to train deep reinforcement learning agents in a <em>multi-agents system</em> to build robust agents that can adapt, collaborate, or compete.",S,v,N="So today we’re going to <strong>learn the basics of the fascinating topic of multi-agents reinforcement learning (MARL)</strong>.",k,w,Q="And the most exciting part is that, during this unit, you’re going to train your first agents in a multi-agents system: <strong>a 2vs2 soccer team that needs to beat the opponent team</strong>.",q,_,V='And you’re going to participate in <strong>AI vs. AI challenge</strong> where your trained agent will compete against other classmates’ agents every day and be ranked on a <a href="https://huggingface.co/spaces/huggingface-projects/AIvsAI-SoccerTwos" rel="nofollow">new leaderboard</a>.',E,y,W='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/soccertwos.gif" alt="SoccerTwos"/> <figcaption>This environment was made by the <a href="https://github.com/Unity-Technologies/ml-agents">Unity MLAgents Team</a></figcaption>',U,T,X="So let’s get started!",R,M,j;return g=new pt({props:{title:"Introduction",local:"introduction",headingTag:"h1"}}),{c(){u=i("meta"),L=s(),x=i("p"),H=s(),st(g.$$.fragment),b=s(),c=i("img"),C=s(),m=i("p"),m.innerHTML=B,P=s(),p=i("p"),p.textContent=O,A=s(),f=i("figure"),f.innerHTML=D,$=s(),h=i("p"),h.innerHTML=J,I=s(),d=i("p"),d.innerHTML=K,S=s(),v=i("p"),v.innerHTML=N,k=s(),w=i("p"),w.innerHTML=Q,q=s(),_=i("p"),_.innerHTML=V,E=s(),y=i("figure"),y.innerHTML=W,U=s(),T=i("p"),T.textContent=X,R=s(),M=i("p"),this.h()},l(t){const e=ot("svelte-u9bgzb",document.head);u=o(e,"META",{name:!0,content:!0}),e.forEach(n),L=l(t),x=o(t,"P",{}),Y(x).forEach(n),H=l(t),lt(g.$$.fragment,t),b=l(t),c=o(t,"IMG",{src:!0,alt:!0}),C=l(t),m=o(t,"P",{"data-svelte-h":!0}),r(m)!=="svelte-smsux1"&&(m.innerHTML=B),P=l(t),p=o(t,"P",{"data-svelte-h":!0}),r(p)!=="svelte-e9caw3"&&(p.textContent=O),A=l(t),f=o(t,"FIGURE",{"data-svelte-h":!0}),r(f)!=="svelte-so1y2c"&&(f.innerHTML=D),$=l(t),h=o(t,"P",{"data-svelte-h":!0}),r(h)!=="svelte-nf786x"&&(h.innerHTML=J),I=l(t),d=o(t,"P",{"data-svelte-h":!0}),r(d)!=="svelte-5dt70f"&&(d.innerHTML=K),S=l(t),v=o(t,"P",{"data-svelte-h":!0}),r(v)!=="svelte-19g4sgk"&&(v.innerHTML=N),k=l(t),w=o(t,"P",{"data-svelte-h":!0}),r(w)!=="svelte-ywv0q0"&&(w.innerHTML=Q),q=l(t),_=o(t,"P",{"data-svelte-h":!0}),r(_)!=="svelte-16qx50q"&&(_.innerHTML=V),E=l(t),y=o(t,"FIGURE",{"data-svelte-h":!0}),r(y)!=="svelte-100gprn"&&(y.innerHTML=W),U=l(t),T=o(t,"P",{"data-svelte-h":!0}),r(T)!=="svelte-2tvssp"&&(T.textContent=X),R=l(t),M=o(t,"P",{}),Y(M).forEach(n),this.h()},h(){G(u,"name","hf:doc:metadata"),G(u,"content",ht),tt(c.src,z="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit0/thumbnail.png")||G(c,"src",z),G(c,"alt","Thumbnail")},m(t,e){rt(document.head,u),a(t,L,e),a(t,x,e),a(t,H,e),ut(g,t,e),a(t,b,e),a(t,c,e),a(t,C,e),a(t,m,e),a(t,P,e),a(t,p,e),a(t,A,e),a(t,f,e),a(t,$,e),a(t,h,e),a(t,I,e),a(t,d,e),a(t,S,e),a(t,v,e),a(t,k,e),a(t,w,e),a(t,q,e),a(t,_,e),a(t,E,e),a(t,y,e),a(t,U,e),a(t,T,e),a(t,R,e),a(t,M,e),j=!0},p:et,i(t){j||(gt(g.$$.fragment,t),j=!0)},o(t){ct(g.$$.fragment,t),j=!1},d(t){t&&(n(L),n(x),n(H),n(b),n(c),n(C),n(m),n(P),n(p),n(A),n(f),n($),n(h),n(I),n(d),n(S),n(v),n(k),n(w),n(q),n(_),n(E),n(y),n(U),n(T),n(R),n(M)),n(u),mt(g,t)}}}const ht='{"title":"Introduction","local":"introduction","sections":[],"depth":1}';function dt(F){return nt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class yt extends at{constructor(u){super(),it(this,u,dt,ft,Z,{})}}export{yt as component};
