import{s as Le,n as _e,o as He}from"../chunks/scheduler.37c15a92.js";import{S as be,i as Ce,g as l,s as a,r as Z,A as ze,h as r,f as n,c as s,j as $e,u as ee,x as o,k as Me,y as Pe,a as i,v as te,d as ne,t as ie,w as ae}from"../chunks/index.7cb9c9b8.js";import{Y as ke}from"../chunks/Youtube.8666c400.js";import{H as se}from"../chunks/Heading.d3928e2a.js";function Ie(le){let m,k,z,I,c,A,u,re='For this section, you’re going to watch this excellent introduction to multi-agents made by <a href="https://www.youtube.com/channel/UCq0imsn84ShAe9PBOFnoIrg">Brian Douglas </a>.',R,p,S,g,oe="In this video, Brian talked about how to design multi-agent systems. He specifically took a multi-agents system of vacuum cleaners and asked: <strong>how can can cooperate with each other</strong>?",q,h,me="We have two solutions to design this multi-agent reinforcement learning system (MARL).",D,f,E,v,ce='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/decentralized.png" alt="Decentralized"/> <figcaption>Source: <a href="https://www.youtube.com/watch?v=qgb0gyrpiGk">Introduction to Multi-Agent Reinforcement Learning</a></figcaption>',U,d,ue="In decentralized learning, <strong>each agent is trained independently from the others</strong>. In the example given, each vacuum learns to clean as many places as it can <strong>without caring about what other vacuums (agents) are doing</strong>.",F,w,pe="The benefit is that <strong>since no information is shared between agents, these vacuums can be designed and trained like we train single agents</strong>.",G,y,ge="The idea here is that <strong>our training agent will consider other agents as part of the environment dynamics</strong>. Not as agents.",j,x,he=`However, the big drawback of this technique is that it will <strong>make the environment non-stationary</strong> since the underlying Markov decision process changes over time as other agents are also interacting in the environment.
And this is problematic for many Reinforcement Learning algorithms <strong>that can’t reach a global optimum with a non-stationary environment</strong>.`,B,T,W,$,fe='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit10/centralized.png" alt="Centralized"/> <figcaption>Source: <a href="https://www.youtube.com/watch?v=qgb0gyrpiGk">Introduction to Multi-Agent Reinforcement Learning</a></figcaption>',Y,M,ve="In this architecture, <strong>we have a high-level process that collects agents’ experiences</strong>: the experience buffer. And we’ll use these experiences <strong>to learn a common policy</strong>.",N,L,de="For instance, in the vacuum cleaner example, the observation will be:",O,_,we="<li>The coverage map of the vacuums.</li> <li>The position of all the vacuums.</li>",J,H,ye=`We use that collective experience <strong>to train a policy that will move all three robots in the most beneficial way as a whole</strong>. So each robot is learning from their common experience.
We now have a stationary environment since all the agents are treated as a larger entity, and they know the change of other agents’ policies (since it’s the same as theirs).`,K,b,xe="If we recap:",Q,C,Te="<li><p>In a <em>decentralized approach</em>, we <strong>treat all agents independently without considering the existence of the other agents.</strong></p> <ul><li>In this case, all agents <strong>consider others agents as part of the environment</strong>.</li> <li><strong>It’s a non-stationarity environment condition</strong>, so has no guarantee of convergence.</li></ul></li> <li><p>In a <em>centralized approach</em>:</p> <ul><li>A <strong>single policy is learned from all the agents</strong>.</li> <li>Takes as input the present state of an environment and the policy outputs joint actions.</li> <li>The reward is global.</li></ul></li>",V,P,X;return c=new se({props:{title:"Designing Multi-Agents systems",local:"designing-multi-agents-systems",headingTag:"h1"}}),p=new ke({props:{id:"qgb0gyrpiGk"}}),f=new se({props:{title:"Decentralized system",local:"decentralized-system",headingTag:"h2"}}),T=new se({props:{title:"Centralized approach",local:"centralized-approach",headingTag:"h2"}}),{c(){m=l("meta"),k=a(),z=l("p"),I=a(),Z(c.$$.fragment),A=a(),u=l("p"),u.innerHTML=re,R=a(),Z(p.$$.fragment),S=a(),g=l("p"),g.innerHTML=oe,q=a(),h=l("p"),h.textContent=me,D=a(),Z(f.$$.fragment),E=a(),v=l("figure"),v.innerHTML=ce,U=a(),d=l("p"),d.innerHTML=ue,F=a(),w=l("p"),w.innerHTML=pe,G=a(),y=l("p"),y.innerHTML=ge,j=a(),x=l("p"),x.innerHTML=he,B=a(),Z(T.$$.fragment),W=a(),$=l("figure"),$.innerHTML=fe,Y=a(),M=l("p"),M.innerHTML=ve,N=a(),L=l("p"),L.textContent=de,O=a(),_=l("ul"),_.innerHTML=we,J=a(),H=l("p"),H.innerHTML=ye,K=a(),b=l("p"),b.textContent=xe,Q=a(),C=l("ul"),C.innerHTML=Te,V=a(),P=l("p"),this.h()},l(e){const t=ze("svelte-u9bgzb",document.head);m=r(t,"META",{name:!0,content:!0}),t.forEach(n),k=s(e),z=r(e,"P",{}),$e(z).forEach(n),I=s(e),ee(c.$$.fragment,e),A=s(e),u=r(e,"P",{"data-svelte-h":!0}),o(u)!=="svelte-s0u6gv"&&(u.innerHTML=re),R=s(e),ee(p.$$.fragment,e),S=s(e),g=r(e,"P",{"data-svelte-h":!0}),o(g)!=="svelte-12o0rkz"&&(g.innerHTML=oe),q=s(e),h=r(e,"P",{"data-svelte-h":!0}),o(h)!=="svelte-h4778x"&&(h.textContent=me),D=s(e),ee(f.$$.fragment,e),E=s(e),v=r(e,"FIGURE",{"data-svelte-h":!0}),o(v)!=="svelte-18z4kzt"&&(v.innerHTML=ce),U=s(e),d=r(e,"P",{"data-svelte-h":!0}),o(d)!=="svelte-ljzs98"&&(d.innerHTML=ue),F=s(e),w=r(e,"P",{"data-svelte-h":!0}),o(w)!=="svelte-3o4vn0"&&(w.innerHTML=pe),G=s(e),y=r(e,"P",{"data-svelte-h":!0}),o(y)!=="svelte-c8dx7v"&&(y.innerHTML=ge),j=s(e),x=r(e,"P",{"data-svelte-h":!0}),o(x)!=="svelte-z6wvuu"&&(x.innerHTML=he),B=s(e),ee(T.$$.fragment,e),W=s(e),$=r(e,"FIGURE",{"data-svelte-h":!0}),o($)!=="svelte-ltt229"&&($.innerHTML=fe),Y=s(e),M=r(e,"P",{"data-svelte-h":!0}),o(M)!=="svelte-ypcoh6"&&(M.innerHTML=ve),N=s(e),L=r(e,"P",{"data-svelte-h":!0}),o(L)!=="svelte-1owod73"&&(L.textContent=de),O=s(e),_=r(e,"UL",{"data-svelte-h":!0}),o(_)!=="svelte-dln72i"&&(_.innerHTML=we),J=s(e),H=r(e,"P",{"data-svelte-h":!0}),o(H)!=="svelte-14wt5x8"&&(H.innerHTML=ye),K=s(e),b=r(e,"P",{"data-svelte-h":!0}),o(b)!=="svelte-1uwte4"&&(b.textContent=xe),Q=s(e),C=r(e,"UL",{"data-svelte-h":!0}),o(C)!=="svelte-1h1njmy"&&(C.innerHTML=Te),V=s(e),P=r(e,"P",{}),$e(P).forEach(n),this.h()},h(){Me(m,"name","hf:doc:metadata"),Me(m,"content",Ae)},m(e,t){Pe(document.head,m),i(e,k,t),i(e,z,t),i(e,I,t),te(c,e,t),i(e,A,t),i(e,u,t),i(e,R,t),te(p,e,t),i(e,S,t),i(e,g,t),i(e,q,t),i(e,h,t),i(e,D,t),te(f,e,t),i(e,E,t),i(e,v,t),i(e,U,t),i(e,d,t),i(e,F,t),i(e,w,t),i(e,G,t),i(e,y,t),i(e,j,t),i(e,x,t),i(e,B,t),te(T,e,t),i(e,W,t),i(e,$,t),i(e,Y,t),i(e,M,t),i(e,N,t),i(e,L,t),i(e,O,t),i(e,_,t),i(e,J,t),i(e,H,t),i(e,K,t),i(e,b,t),i(e,Q,t),i(e,C,t),i(e,V,t),i(e,P,t),X=!0},p:_e,i(e){X||(ne(c.$$.fragment,e),ne(p.$$.fragment,e),ne(f.$$.fragment,e),ne(T.$$.fragment,e),X=!0)},o(e){ie(c.$$.fragment,e),ie(p.$$.fragment,e),ie(f.$$.fragment,e),ie(T.$$.fragment,e),X=!1},d(e){e&&(n(k),n(z),n(I),n(A),n(u),n(R),n(S),n(g),n(q),n(h),n(D),n(E),n(v),n(U),n(d),n(F),n(w),n(G),n(y),n(j),n(x),n(B),n(W),n($),n(Y),n(M),n(N),n(L),n(O),n(_),n(J),n(H),n(K),n(b),n(Q),n(C),n(V),n(P)),n(m),ae(c,e),ae(p,e),ae(f,e),ae(T,e)}}}const Ae='{"title":"Designing Multi-Agents systems","local":"designing-multi-agents-systems","sections":[{"title":"Decentralized system","local":"decentralized-system","sections":[],"depth":2},{"title":"Centralized approach","local":"centralized-approach","sections":[],"depth":2}],"depth":1}';function Re(le){return He(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ue extends be{constructor(m){super(),Ce(this,m,Re,Ie,Le,{})}}export{Ue as component};
